use std::path::PathBuf;

use clap::{Parser, Subcommand};
use color_eyre::Result;

#[derive(Debug, Parser)]
#[command(author, version, about, long_about = None)]
#[command(propagate_version = true)]
struct Cli {
    #[command(subcommand)]
    command: Commands,
}

#[derive(Clone, Debug, Subcommand)]
enum Commands {
    Pr {
        #[command(subcommand)]
        action: Action,
    },
}

#[derive(Clone, Debug, Subcommand)]
pub(crate) enum Action {
    Check,
    In { dest: PathBuf },
    Out,
}

mod types;
mod cmd {
    pub mod pr;
}

// #[tracing::instrument]
fn main() -> Result<()> {
    let cli = Cli::parse();

    match &cli.command {
        Commands::Pr { action } => cmd::pr::run(action),
    }
}
